import re
import socket
import tempfile
import unittest
from contextlib import closing

import numpy as np
from time import clock as time_now
from numpy.testing import assert_array_almost_equal

from shyft.api import Calendar
from shyft.api import DtsClient
from shyft.api import DtsServer
from shyft.api import IntVector
from shyft.api import StringVector
from shyft.api import TimeAxis
from shyft.api import TimeSeries
from shyft.api import TsInfo
from shyft.api import TsInfoVector
from shyft.api import TsVector
from shyft.api import UtcPeriod
from shyft.api import deltahours
from shyft.api import point_interpretation_policy as point_fx
from shyft.api import utctime_now


def shyft_store_url(name: str) -> str:
    return "shyft://test/{}".format(name)  # shyft:// maps to internal, test= container-name
#dtss = DtsServer()
port_no = 20000 #find_free_port()
host_port = f'192.168.38.106:{port_no}'
#dtss.set_auto_cache(True)
#dtss.cache_max_items = 200000
#dtss.set_listening_port(port_no)
#dtss.set_container("test", c_dir)  # notice we set container 'test' to point to c_dir directory
#dtss.start_async()  # the internal shyft time-series will be stored to that container
c = DtsClient(host_port) # start a client we can use
utc=Calendar() # a # calendar to give some time-points
def create_ts_expression(i0:int, n_ts:int)->TsVector:
    tsv = TsVector()
    tsv[:] = [ TimeSeries(shyft_store_url(f"{i0+i}"))  for i in range(n_ts)]
    return tsv
ts_expr=create_ts_expression(1000,10000)
ta=TimeAxis(utc.time(2016,1,1),deltahours(7*24),52*4)
ts_expr_result = c.percentiles(ts_expr,ta.total_period(),ta,[0,25,50,75,100])
ts_expr_result[1].values.to_numpy()